#include "turtel.h"

#include <stdlib.h>
#include <stdarg.h>
#include <dlfcn.h>

static void **loaded = NULL;
static int loaded_n = 0;

void load_dynamic(char *name) {
  loaded_n++;
  loaded = realloc(loaded, sizeof(void*) * loaded_n);
  loaded[loaded_n-1] = dlopen(name, RTLD_NOW);

  if (loaded[loaded_n-1] == NULL)
    err("couldn't load '%s'", name);
}

void run_dynamic_fn(char *fn, char *fmt, ...) {
  va_list vl;
  int i;
  void (*fnp)(void *, ...) = NULL;
  va_start(vl, fmt);
  vfprintf(stderr, fmt, vl);

  for (i = 0; i < loaded_n; ++i) {
    fnp = dlsym(loaded[i], fn);
    if (fn != NULL)
      break;
  }

  if (fn == NULL)
    err("couldnt find function %s in loaded libraries", fn);

  fnp(vl);
}

